{--------------------------------------------------------}
{                                                        }
{    Grafivox - gerador de grficos para cegos           }
{                                                        }
{    Mdulo de configurao da impressora                }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em agosto/2018                                      }
{                                                        }
{--------------------------------------------------------}

unit gfConfPrn;

interface
uses
    dvcrt, dvwin, dvform,
    windows, classes, graphics, sysutils, WinSpool,
    gfvars, gfmsg, gfArq;

function alocaImpressora (nomeImpressora: string): boolean;
procedure fechaImpressora;
function  escreveDispositivo (texto: string): boolean;

function escolheImprPadrao: string;

implementation

var
    hPrn: THandle;

{--------------------------------------------------------}

function alocaImpressora (nomeImpressora: string): boolean;
var
    title: array [0..200] of char;
    DocInfo1 : TDocInfo1;

begin
    result := false;

    if not OpenPrinter(PChar(nomeImpressora), hPrn, nil) then Exit;

    strPCopy (title, 'Grafivox');
    DocInfo1.pDocName    := title;
    DocInfo1.pOutputFile := NIL;
    DocInfo1.pDataType   := 'RAW';

    if StartDocPrinter(hPrn, 1, @DocInfo1) = 0 then exit;
    if not StartPagePrinter(hPrn) then
    begin
        EndDocPrinter(hPrn);
        exit;
    end;

    result := true;
end;

{--------------------------------------------------------}

procedure fechaImpressora;
begin
    EndPagePrinter(hPrn);
    EndDocPrinter(hPrn);
    ClosePrinter(hPrn);
end;

{--------------------------------------------------------}

function escreveDispositivo (texto: string): boolean;
var
    nesc: Cardinal;
begin
    WritePrinter(hPrn, @texto[1], length(texto), nesc);
    result := integer(nesc) = integer(length(texto));
end;

{--------------------------------------------------------}
{             imprime canvas na impressora               }
{--------------------------------------------------------}

function escolheImprPadrao: string;
var
    impressoras: TStringList;
    i: integer;

begin
    result := '';
    impressoras := sintItensAmbienteArq('Devices', 'win.ini');
    popupMenuCria(whereX, whereY, 60, impressoras.Count, RED);

    garanteEspacoTela(impressoras.Count);
    for i := 0 to impressoras.Count-1 do
      popupMenuAdiciona('', impressoras[i]);
    i := popupMenuSeleciona;

    if i > 0 then
        result := impressoras[i-1];

    impressoras.Free;
end;

end.

