{--------------------------------------------------------}
{                                                        }
{    Grafivox - gerador de grficos para cegos           }
{                                                        }
{    Mdulo de mensagens                                 }
{                                                        }
{    Autor:  Jos Antonio Borges                         }
{                                                        }
{    Em agosto/2018                                      }
{                                                        }
{--------------------------------------------------------}

unit gfmsg;

interface

uses
    dvcrt,
    dvWin,
    dvWav,
    windows,
    sysUtils,
    gfvars;

function pegaTextoMensagem (nomeArq: string): string;
procedure mensagem (nomeArq: string; nlf: integer);
procedure limpaBaixo (y: integer);
procedure naoImplem;
procedure tituloJanela (s: string);
procedure banner;

implementation

{--------------------------------------------------------}
{              descobre o texto da mensagem
{--------------------------------------------------------}

function pegaTextoMensagem (nomeArq: string): string;
var s: string;
begin
    if nomeArq = 'GFINIC' then
        s := 'Grafivox - '
    else
    if nomeArq = 'GFFIM' then
        s := 'Fim do Grafivox'
    else
    if nomeArq = 'GFOK' then
        s := 'OK.'
    else
    if nomeArq = 'GFMOMENT' then
        s := 'Um momento...'
    else
    if nomeArq = 'GFOQUE' then
        s := 'Grafivox - Que deseja? '
    else
    if nomeArq = 'GFOPINV' then
        s := 'Opo invlida'
    else
    if nomeArq = 'GFDESIST' then
        s := 'Desistiu...'
    else
    if nomeArq = 'GFOPCAO' then
        s := 'As opes so:'
    else
    if nomeArq = 'GFEDIT' then
        s := 'Editando: digite os comandos'
    else
    if nomeArq = 'GFOPC_P' then
        s := 'P - passo-a-passo interativo'
    else
    if nomeArq = 'GFOPC_E' then
        s := 'E - editar os comandos para graficar'
    else
    if nomeArq = 'GFOPC_V' then
        s := 'V - visualizar'
    else
    if nomeArq = 'GFOPC_S' then
        s := 'S - salvar os comandos grficos'
    else
    if nomeArq = 'GFOPC_B' then
        s := 'B - imprimir em Braille'
    else
    if nomeArq = 'GFOPC_I' then
        s := 'I - imprimir em tinta'
    else
    if nomeArq = 'GFOPC_G' then
        s := 'G - gravar imagem do grfico'
    else
    if nomeArq = 'GFOPC_C' then
        s := 'C - configurar'
    else
    if nomeArq = 'GFOPC_N' then
        s := 'N - novo grfico'
    else
    if nomeArq = 'GF_ESC' then
        s := 'ESC - terminar'
    else

    if nomeArq = 'GFAPTENT' then
        s := 'Aperte enter...'
    else
    if nomeArq = 'GFCNFFIM' then
        s := 'Confirma o fim do grafivox? '
    else
    if nomeArq = 'GFNAOGV' then
        s := 'O projeto ainda no foi salvo.'
    else
    if nomeArq = 'GFCNFNGV' then
        s := 'Confirma que no quer gravar? '
    else

    if nomeArq = 'GFNOMARQ' then
        s := 'Informe o nome do arquivo'
    else
    if nomeArq = 'GFASSUME' then
        s := 'Assumido desenho.grm'
    else
    if nomeArq = 'GFARQNOV' then
        s := 'Arquivo novo'
    else
    if nomeArq = 'GFARQCRG' then
        s := 'Arquivo carregado'
    else
    if nomeArq = 'GFAPTF9' then
        s := 'Aperte F9 para ajuda'
    else
    if nomeArq = 'GFCANC' then
        s := 'Cancelado'
    else
    if nomeArq = 'GFSALVAR' then
        s := 'Quer salvar o arquivo (S/N)? '

    else
    if nomeArq = 'GFERRFNT' then
        s := 'Erro: no encontrei a fonte das letras!'
    else
    if nomeArq = 'GFNOMGRF' then
        s := 'Informe o arquivo JPG ou PNG a gravar'
    else
    if nomeArq = 'GFSOBRESC' then
        s := 'Arquivo j existe, sobrescreve? '
    else
    if nomeArq = 'GFOK' then
        s := 'OK'

    else
    if nomeArq = 'GFDIGCOM' then
        s := 'Digite o comando: '
    else
    if nomeArq = 'GFCOM_DM' then
        s := 'DM - Definir domnio'
    else
    if nomeArq = 'GFCOM_CM' then
        s := 'CD - Definir contradomnio'
    else
    if nomeArq = 'GFCOM_EX' then
        s := 'EX - Definir Eixo X'
    else
    if nomeArq = 'GFCOM_EY' then
        s := 'EY - Definir Eixo Y'
    else
    if nomeArq = 'GFCOM_GR' then
        s := 'GR - Definir Grade'

    else
    if nomeArq = 'GFCOM_PT' then
        s := 'PT - Ponto'
    else
    if nomeArq = 'GFCOM_RT' then
        s := 'RT - Reta'
    else
    if nomeArq = 'GFCOM_ST' then
        s := 'ST - Seta'
    else
    if nomeArq = 'GFCOM_RG' then
        s := 'RG - Retngulo'
    else
    if nomeArq = 'GFCOM_RR' then
        s := 'RR - Retngulo rodado'

    else
    if nomeArq = 'GFCOM_PO' then
        s := 'PO - Polgono'
    else
    if nomeArq = 'GFCOM_CI' then
        s := 'CI - Circunferncia'
    else
    if nomeArq = 'GFCOM_EL' then
        s := 'EL - Elipse'
    else
    if nomeArq = 'GFCOM_PA' then
        s := 'PA - Parbola'
    else
    if nomeArq = 'GFCOM_CV' then
        s := 'CV - Curva'
    else
    if nomeArq = 'GFCOM_PN' then
        s := 'PN - Polinmio'
    else
    if nomeArq = 'GFCOM_EQ' then
        s := 'EQ - Equao'
    else
    if nomeArq = 'GFCOM_LD' then
        s := 'LD - Le dados de arquivo'

    else
    if nomeArq = 'GFCOM_TB' then
        s := 'TX - Texto em Braille'
    else
    if nomeArq = 'GFCOM_TT' then
        s := 'TT - Texto em Tinta'

    else
    if nomeArq = 'GFCOM_CC' then
        s := 'CC - Configurar Caneta'
    else
    if nomeArq = 'GFCOM_CT' then
        s := 'CT - Configurar Texto em Tinta'
    else
    if nomeArq = 'GFCOM_HI' then
        s := 'HI - Histograma'
    else
    if nomeArq = 'GF_DOMIN' then
        s := 'Domnio'
    else
    if nomeArq = 'GF_CTDOM' then
        s := 'Contradomnio'
    else
    if nomeArq = 'GF_EIXO' then
        s := 'Eixo'
    else
    if nomeArq = 'GF_GRADE' then
        s := 'Grade'

    else
    if nomeArq = 'GF_RETA' then
        s := 'Reta'
    else
    if nomeArq = 'GF_SETA' then
        s := 'Seta'
    else
    if nomeArq = 'GF_RETANG' then
        s := 'Retngulo'
    else
    if nomeArq = 'GF_PONTO' then
        s := 'Ponto'
    else
    if nomeArq = 'GF_POLIG' then
        s := 'Polgono'
    else
    if nomeArq = 'GF_CIRC' then
        s := 'Circunferncia'
    else
    if nomeArq = 'GF_ELIPSE' then
        s := 'Elipse'
    else
    if nomeArq = 'GF_PARAB' then
        s := 'Parbola'
    else
    if nomeArq = 'GF_CURVA' then
        s := 'Curva'
    else
    if nomeArq = 'GF_POLIN' then
        s := 'Polinmio'
    else
    if nomeArq = 'GF_EQUACAO' then
        s := 'Equao'
    else
    if nomeArq = 'GF_LEDADOS' then
        s := 'Leitura de dados'
    else
    if nomeArq = 'GF_CANETA' then
        s := 'Configurao da caneta'
    else
    if nomeArq = 'GF_TXTB' then
        s := 'Texto em Braille'
    else
    if nomeArq = 'GF_TXTT' then
        s := 'Texto em Tinta'
    else
    if nomeArq = 'GF_CNFTINTA' then
        s := 'Configurao do texto em tinta'
    else
    if nomeArq = 'GF_PINTER' then
        s := 'Passo-a-passo interativo'

//  else
//  if nomeArq = 'DFDIGNOME' then
//      s := 'Nome'

    else
    if nomeArq = 'GF_FORM' then
        s := 'Formulrio'
    else
    if nomeArq = 'GF_COORD' then
        s := 'Coordenadas: '
    else
    if nomeArq = 'GF_CINIC' then
        s := 'Coordenada Inicial: '
    else
    if nomeArq = 'GF_CFINAL' then
        s := 'Coordenada Final: '
    else
    if nomeArq = 'GF_PTI' then
        s := 'Ponto inicial: '
    else
    if nomeArq = 'GF_PTF' then
        s := 'Ponto final: '
    else
    if nomeArq = 'GF_INDF' then
        s := 'Ponto inferior esquerdo: '
    else
    if nomeArq = 'GF_DIME' then
        s := 'Dimenses X e Y: '
    else
    if nomeArq = 'GF_ANG' then
        s := 'ngulo em graus: '
    else
    if nomeArq = 'GF_XMIN' then
        s := 'X mnimo: '
    else
    if nomeArq = 'GF_YMIN' then
        s := 'Y mnimo: '
    else
    if nomeArq = 'GF_XMAX' then
        s := 'X mximo: '
    else
    if nomeArq = 'GF_YMAX' then
        s := 'Y mximo: '
    else
    if nomeArq = 'GF_0_1' then
        s := 'Valores entre 0 e 1 '
    else
    if nomeArq = 'GF_JXMIN' then
        s := 'X mnimo (sugiro 0): '
    else
    if nomeArq = 'GF_JYMIN' then
        s := 'Y mnimo (sugiro 0): '
    else
    if nomeArq = 'GF_JXMAX' then
        s := 'X mximo (sugiro 1.0): '
    else
    if nomeArq = 'GF_JYMAX' then
        s := 'Y mximo (sugiro 1.0): '
    else
    if nomeArq = 'GF_CENTRO' then
        s := 'Centro: '
    else
    if nomeArq = 'GF_RAIO' then
        s := 'Raio: '
    else
    if nomeArq = 'GF_DXDY' then
        s := 'dx dy: '
    else
    if nomeArq = 'GF_DEIXBR' then
        s := 'Deixe em branco os pontos inexistentes'
    else
    if nomeArq = 'GF_DEIXBV' then
        s := 'Deixe em branco os valores inexistentes'
    else
    if nomeArq = 'GF_NPTS' then
        s := 'Nmero de pontos: '
    else
    if nomeArq = 'GF_PT1' then
        s := 'Ponto 1: '
    else
    if nomeArq = 'GF_PT2' then
        s := 'Ponto 2: '
    else
    if nomeArq = 'GF_PT3' then
        s := 'Ponto 3: '
    else
    if nomeArq = 'GF_PT4' then
        s := 'Ponto 4: '
    else
    if nomeArq = 'GF_PT5' then
        s := 'Ponto 5: '
    else
    if nomeArq = 'GF_GRAU' then
       s := 'Grau: '
    else
    if nomeArq = 'GF_CX4' then
       s := 'Coef. x^4: '
    else
    if nomeArq = 'GF_CX3' then
       s := 'Coef. x^3: '
    else
    if nomeArq = 'GF_CX2' then
       s := 'Coef. x^2: '
    else
    if nomeArq = 'GF_CX1' then
       s := 'Coef. x: '
    else
    if nomeArq = 'GF_CX0' then
       s := 'Termo independente: '

    else
    if nomeArq = 'GF_TEXTO' then
        s := 'Texto: '
    else
    if nomeArq = 'GF_ITICK' then
        s := 'Intervalo entre marcas: '
    else
    if nomeArq = 'GF_ITICKX' then
        s := 'Intervalo X entre marcas: '
    else
    if nomeArq = 'GF_ITICKY' then
        s := 'Intervalo Y entre marcas: '
    else
    if nomeArq = 'GF_HISTO' then
        s := 'Histograma: '
    else
    if nomeArq = 'GF_LARGB' then
        s := 'Largura das barras: '
    else
    if nomeArq = 'GF_NBRS' then
        s := 'Nmero de Barras: '
    else
    if nomeArq = 'GF_PBR1' then
        s := 'Barra 1: '
    else
    if nomeArq = 'GF_PBR2' then
        s := 'Barra 2: '
    else
    if nomeArq = 'GF_PBR3' then
        s := 'Barra 3: '
    else
    if nomeArq = 'GF_PBR4' then
        s := 'Barra 4: '
    else
    if nomeArq = 'GF_PBR5' then
        s := 'Barra 5: '
    else
    if nomeArq = 'GF_PBR6' then
        s := 'Barra 6: '
    else
    if nomeArq = 'GF_PBR7' then
        s := 'Barra 7: '
    else
    if nomeArq = 'GF_PBR8' then
        s := 'Barra 8: '
    else
    if nomeArq = 'GF_PBR9' then
        s := 'Barra 9: '
    else
    if nomeArq = 'GF_PBR10' then
        s := 'Barra 10: '
    else
    if nomeArq = 'GF_PBR11' then
        s := 'Barra 11: '
    else
    if nomeArq = 'GF_PBR12' then
        s := 'Barra 12: '
    else

    if nomeArq = 'GFNAOSV' then
        s := 'Arquivo grfico no foi salvo.'
    else
    if nomeArq = 'GF_ERRL' then
        s := 'Erro na linha '
    else
    if nomeArq = 'GFINVAL' then
        s := 'Dados incompletos'
    else
    if nomeArq = 'GFSTINTA' then
        s := 'Selecione a impressora a tinta'
    else
    if nomeArq = 'GFERRDSP' then
        s := 'Erro no dispositivo'
    else
    if nomeArq = 'GFSBRL' then
        s := 'Selecione a impressora Braille'
    else
    if nomeArq = 'GFIMPREM' then
        s := 'Imprimindo em '
    else
    if nomeArq = 'GFPROBLI' then
        s := 'Problemas na impressora.'
    else
    if nomeArq = 'GFIMPROK' then
        s := 'Impressora ok. Iniciando impresso.'
    else
    if nomeArq = 'GFSTINTA' then
        s := 'Selecione a impressora a tinta'
    else
    if nomeArq = 'GFPDEITA' then
        s := 'Imprime com papel deitado'
    else
    if nomeArq = 'GFTAMPAP' then
        s := 'Tamanho do papel (em pixels): '
    else
    if nomeArq = 'GFSBRL' then
        s := 'Selecione a impressora braille'
    else
    if nomeArq = 'GF_QLDADOS' then
        s := 'Quer utilizar dados lidos de arquivo? '

    else
    if nomeArq = 'GFNIMPL' then
        s := 'No implementado'
    else
        s := '--> Mensagem invlida: ' + nomeArq;

   pegaTextoMensagem := s;
end;

{--------------------------------------------------------}
{                    d uma mensagem
{--------------------------------------------------------}

procedure mensagem (nomeArq: string; nlf: integer);
var i: integer;
    s: string;
begin
    s := pegaTextoMensagem (nomeArq);

    if nlf >= 0 then write (s);
    for i := 1 to nlf do
         writeln;

    if existeArqSom ('EF_' + nomeArq) then
        sintSom ('EF_' + nomeArq);

    if existeArqSom (nomeArq) then
        sintSom (nomeArq)
    else
        sintetiza (s);
end;

{--------------------------------------------------------}
{       limpa debaixo de certa posio da tela
{--------------------------------------------------------}

procedure limpaBaixo (y: integer);
var i: integer;
begin
    for i := y to 25 do
        begin
            gotoxy (1, i);
            clreol;
        end;
    gotoxy (1, y);
end;

{--------------------------------------------------------}
{     mensagem padro para rotinas ainda no criadas
{--------------------------------------------------------}

procedure naoImplem;
begin
    sintWriteln (pegaTextoMensagem('GFNIMPL'));  {'No implementado'}
    writeln;
end;

{--------------------------------------------------------}
{                 muda o titulo da janela                }
{--------------------------------------------------------}

procedure tituloJanela (s: string);
var nomeJan: array [0..144] of char;
begin
    strPcopy (nomeJan, 'Grafivox ' + s);
    setWindowText (crtWindow, nomeJan);
end;

{--------------------------------------------------------}
{                mostra o banner grafivox                }
{--------------------------------------------------------}

procedure banner;
begin
    clrscr;
    window (7, 1, 73, 7);
    textBackground (BLUE);
    clrscr;

    gotoxy (1, 1);
    writeln (' *****   ******    *****   *******  *****  *     *   *****   *     *');
    writeln ('*     *  *     *  *     *  *          *    *     *  *     *   *   * ');
    writeln ('*        *     *  *     *  *          *    *     *  *     *    * *  ');
    writeln ('*   ***  ******   *******  *****      *    *     *  *     *     *   ');
    writeln ('*     *  *     *  *     *  *          *     *   *   *     *    * *  ');
    writeln ('*     *  *     *  *     *  *          *      * *    *     *   *   * ');
    write   (' *****   *     *  *     *  *        *****     *      *****   *     *');
    textBackground (BLACK);
    window (1, 1, 80, 25);
    gotoxy (1, 9);
end;

end.
